<template>
  <div class="print-button">
    <a href="#" class="button" @click.prevent.stop="print">
      <slot />
    </a>
    <form
      v-if="shouldPrint"
      ref="form"
      style="display: none"
      target="_blank"
      method="POST"
      action="https://caltopo.com/print"
    >
      <input type="hidden" name="state" :value="JSON.stringify(state)" />
    </form>
    <div v-if="showMenu" class="menu">
      <ul>
        <li>
          <a href="#" @click.prevent="caltopoPrint">Print on CalTopo</a>
        </li>
        <li v-for="(map, index) in maps" :key="index">
          <a :href="map.url"
            >Download Map {{ maps.length > 1 ? index + 1 : "" }}</a
          >
        </li>
      </ul>
    </div>
  </div>
</template>
<style lang="scss" scoped>
@import "~assets/mixins";

ul {
  li {
    list-style: none;
  }

  li + li {
    margin-top: $grid * 0.5;
  }
}

.print-button {
  display: flex;
  position: relative;
}

.menu {
  position: absolute;
  padding: $grid * 0.25 $grid;

  bottom: $grid * 2;
  right: $grid * 0.25;
  border-radius: $grid * 0.25;
  width: $grid * 10;

  background-color: white;
  border: $border;
  color: black;
  text-align: right;
}
</style>
<script>
import { get, getter } from "~/lib/utils";

function cpToFeature(cp) {
  return {
    type: "Feature",
    geometry: {
      type: "Point",
      coordinates: [Number(cp.lng), Number(cp.lat)],
    },
    properties: {
      title: cp.name,
      description: cp.description,
      "marker-symbol": "c:ring",
      "marker-color": "#FF0000",
      stroke: "#FF0000",
      "stroke-width": 2,
      "stroke-opacity": 1,
      fill: "#FF0000",
      "fill-opacity": 0.2,
    },
  };
}

function caltopoStateFromCourse(course) {
  var checkpoints = get(course, "checkpoints.nodes");

  return {
    type: "FeatureCollection",
    features: checkpoints.map(cpToFeature),
  };
}

export default {
  props: ["course"],
  data() {
    return {
      shouldPrint: false,
      showMenu: false,
    };
  },
  computed: {
    state: function () {
      return caltopoStateFromCourse(this.course);
    },
    maps: function () {
      return get(this.course, "maps.nodes");
    },
  },
  beforeUnmount() {
    window.document.removeEventListener("click", this.hideMenu);
  },
  methods: {
    print() {
      if (this.showMenu) return (this.showMenu = false);

      this.showMenu = true;
      window.document.addEventListener("click", this.hideMenu);
    },
    hideMenu() {
      this.showMenu = false;
      window.document.removeEventListener("click", this.hideMenu);
    },
    caltopoPrint() {
      this.shouldPrint = true;
      this.$nextTick(() => {
        this.$refs.form.submit();
        this.$nextTick(() => {
          this.shouldPrint = false;
        });
      });
    },
  },
};
</script>
